--------------------------------------------------------------------------------
-- Weapon Heli + Projectile Missile + Projectile heli +Projectile
-- Original Carnage Contest Weapon
-- Script by Loooser, August 2009, www.UnrealSoftware.de
--------------------------------------------------------------------------------

-- Setup Tables
if cc==nil then cc={} end
cc.heli={}
cc.heli.object={}
cc.heli.bullet={}
cc.heli.rocket={}

cc.heli.gfx_heli={}
-- Load & Prepare Ressources
for i =1,4 do
cc.heli.gfx_heli[i]=loadgfx("weapons/heli"..i..".png")-- Heli object Image
setmidhandle(cc.heli.gfx_heli[i])
end

cc.heli.sfx_attack=loadsfx("mg.wav")  -- mg Attack Sound
cc.heli.gfx_pro=loadgfx("weapons/shot.bmp")     -- Bullet Image
setmidhandle(cc.heli.gfx_pro)
cc.heli.sfx_attack2=loadsfx("rocketrelease.wav") -- Rocket Attack Sound
cc.heli.sfx_sound=loadsfx("heli.wav") --Heli Rotor Sound
cc.heli.gfx_pro2=loadgfx("weapons/homingmissile.bmp") -- Rocket Image

--------------------------------------------------------------------------------
-- Weapon: Heli
--------------------------------------------------------------------------------

cc.heli.id=addweapon("cc.heli","Heli",cc.heli.gfx_heli[1],0,2)        -- Add Weapon (0 use, first in round 2)

function cc.heli.draw() -- Draw HUD
        -- HUD Timer (1 for bullets 2 for rockets)
        hudtimer(1,1,2)
	hudinfo("You can change your timer for other weapons!")
        -- HUD Crosshair
        if weapon_shots==0 then
                hudcrosshair(6,3)
        end
end

function cc.heli.attack(attack) -- Attack to start Heli
        if (weapon_shots<=0) and attack==1 then
                -- No more weapon switching!
                useweapon(0)
                -- Disable player control
                playercontrol(0)
                -- Make sure that there is enough round time
                secondsleft=math.floor(getframesleft()/50)
                changeturntime(30-secondsleft)
                -- Only one time usable
                weapon_shots=weapon_shots+1
                --Starting Heli sound
                playsound(cc.heli.sfx_sound,1)
                -- Creating Heli
                local sp = math.random(1,4)
                if sp==1 then
                createobject(cc.heli.object.id,-100,-100)
                elseif sp==2 then
                createobject(cc.heli.object.id,-100,getwatery()-100)
                elseif sp==3 then
                createobject(cc.heli.object.id,getmapwidth()+100,getwatery()-100)
                else
                createobject(cc.heli.object.id,getmapwidth()+100,-100)
                end
        end
end

--------------------------------------------------------------------------------
-- Projectile: Heli
--------------------------------------------------------------------------------

cc.heli.object.id=addobject("cc.heli.object",cc.heli.gfx_pro)

function cc.heli.object.setup(id,parameter) -- Setup
         -- Setup
        if objects==nil then objects={} end
        objects[id]={}
        -- Movements form Heli
        objects[id].sx=0
        objects[id].sy=0
        -- Live time for Heli
        objects[id].timer=30*50
        -- Health from Heli
        objects[id].health=300
        objects[id].lastdir=-1 -- Last direction from Heli
        objects[id].brate=0  -- timer between every shot
        objects[id].player=playercurrent() -- player who used the Heli
        objects[id].sound=3*50 -- timer for Heli sound
        objects[id].frame=1
        objects[id].frameb=1
	objects[id].exists=100
	
end

function cc.heli.object.draw(id,x,y) -- Draw Heli
        -- Setup draw mode
        setblend(blend_alpha)
        setalpha(1)
        setcolor(255,255,255)
        -- setting the direction
        local dir
        if objects[id].sx>0 then
                dir=-1
                objects[id].lastdir=-1
        elseif objects[id].sx<0 then
                dir=1
                objects[id].lastdir=1
        else
        dir=objects[id].lastdir
        end
        setscale(dir,1)
        -- Calculate object rotation according to his speed
        setrotation(math.deg(objects[id].sx/8))
        -- Draw projectile
        objects[id].frame=objects[id].frame+objects[id].frameb
        if objects[id].frame==5 then
        objects[id].frameb=-1
        objects[id].frame=3
        elseif objects[id].frame==0 then
        objects[id].frameb=1
        objects[id].frame=2
        end
        drawimage(cc.heli.gfx_heli[objects[id].frame],x,y)
        -- Draw Arrow if out of Screen
        outofscreenarrow(x,y)
end

function cc.heli.object.update(id,x,y) -- Update
        cc.heli.object.move(id,1,x,y)
end

function cc.heli.object.move(id,fx,x,y)
                if objects[id].health<=0 then
		-- Cause damage
                arealdamage(x,y,120,60)
                -- Destroy terrain
                terrainexplosion(x,y,60,1)
                -- Crater
                grey=math.random(0,40)
                if math.random(0,1)==1 then
                      terrainalphaimage(gfx_crater125,x,y,math.random(6,9)*0.1,grey,grey,grey)
                else
                      terrainalphaimage(gfx_crater150,x,y,math.random(6,9)*0.1,grey,grey,grey)
                end
                stopchannel(1) -- stoping heli rotor sound
                -- Removing Object
                removeobject(id)
		endturn()
                end
         -- restarting heli sound for an loop
         objects[id].sound=objects[id].sound-1
         if objects[id].sound==0 then
                  objects[id].sound=3*50
                  playsound(cc.heli.sfx_sound,1)
         end
         -- if player who started the heli dies then the heli ends
         if objects[id].player~=playercurrent() then
                objects[id].health=0
         end
         -- making the variable counting down
         if objects[id].brate>0 then
                 objects[id].brate=objects[id].brate-1
         end
         -- Control by player
         --movement left and right
         if keydown(key_up)==1 and objects[id].sy>-6 then
                  objects[id].sy=objects[id].sy-0.25
         elseif keydown(key_down)==1 and objects[id].sy<6 then
                  objects[id].sy=objects[id].sy+0.25
         else
                  if objects[id].sy>0 then
                          objects[id].sy=objects[id].sy-0.25
                  elseif objects[id].sy<0 then
                          objects[id].sy=objects[id].sy+0.25
                  end
         end
         -- movement up and down
         if keydown(key_left)==1 and objects[id].sx>-6 then
                  objects[id].sx=objects[id].sx-0.25
         elseif keydown(key_right)==1 and objects[id].sx<6 then
                  objects[id].sx=objects[id].sx+0.25
         else
                  if objects[id].sx>0 then
                          objects[id].sx=objects[id].sx-0.25
                  elseif objects[id].sx<0 then
                          objects[id].sx=objects[id].sx+0.25
                  end
         end
         -- on attack fire selected weapon
         if keydown(key_attack)==1 and objects[id].brate<=0 and weapon_timer==1 then
               objects[id].brate=5
               playsound(cc.heli.sfx_attack)
               local pid=createprojectile(cc.heli.bullet.id)
               projectiles[pid]={}
               -- Ignore Object
               projectiles[pid].ignore=id
               -- Set initial position of projectile
               projectiles[pid].x=x+objects[id].lastdir*-20
               projectiles[pid].y=y+20+math.abs(objects[id].sx)*5
               -- Set speed of projectile
               math.randomseed(objects[id].timer*12345)
               offset=-6.0+math.random()*12.0
               projectiles[pid].sx=math.sin(math.rad(-90*objects[id].lastdir+math.deg(objects[id].sx/8)+offset))*15.0
               projectiles[pid].sy=-math.cos(math.rad(-90*objects[id].lastdir+math.deg(objects[id].sx/8)+offset))*15.0
               -- Initial movement
               projectiles[pid].x=projectiles[pid].x-objects[id].lastdir*20
               cc.heli.bullet.move(pid)
               -- Effects
               particle(p_muzzle,projectiles[pid].x,projectiles[pid].y)
               particle(p_smoke,projectiles[pid].x,projectiles[pid].y)
               particlespeed(-0.2+math.random()*0.4+getwind()*10.0,-1.0+math.random()*0.6)
               particlefadealpha(0.005)
               particle(p_bullet,x+objects[id].lastdir*-30,y+20)
         elseif keydown(key_attack)==1 and objects[id].brate<=0 and weapon_timer==2 then
               objects[id].brate=40
               playsound(cc.heli.sfx_attack2)
               tid=createprojectile(cc.heli.rocket.id)
               projectiles[tid]={}
               -- Ignore collision with current player at beginning
               projectiles[tid].ignore=id
               -- Set initial position of projectile
               projectiles[tid].x=x+objects[id].lastdir*-10
               projectiles[tid].y=y+25+math.abs(objects[id].sx)*5
               -- Set Timer
               projectiles[tid].timer=15
               -- Initial movement
               projectiles[tid].rot=-90*objects[id].lastdir+math.deg(objects[id].sx/8)
               projectiles[tid].sx=objects[id].sx
               projectiles[tid].sy=objects[id].sy
               projectiles[tid].x=projectiles[tid].x-projectiles[tid].sx
               projectiles[tid].y=projectiles[tid].y-projectiles[tid].sy
         end
         -- Particle Tail
         if (fx==1) then
               if objects[id].health<50 and objects[id].frame==1 then
               particle(p_spark,x+20*objects[id].lastdir,y+25+math.abs(objects[id].sx)*-5)
               particlespeed(objects[id].lastdir,math.random(-2,2)*0.1)
               particlefadealpha(0.01)
               end
               particle(p_smoke,x+20*objects[id].lastdir,y+25+math.abs(objects[id].sx)*-5)
               particlespeed(objects[id].lastdir,math.random(-4,-1)*0.1)
               particlefadealpha(0.01)
         end

        -- Wind influence on speed
        --objects[id].sx=objects[id].sx+getwind()

        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(objects[id].sx),math.abs(objects[id].sy))/3)
        msubx=objects[id].sx/msubt
        msuby=objects[id].sy/msubt
        for i=1,msubt,1 do
                x=x+msubx
                y=y+msuby
                -- Collision
                if collision(cc.heli.gfx_heli[1],x,y,1,1,1,-1,id)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision()>0 then
                                objects[id].health=0
                                break
                        end
                end
                -- Water
                if y>getwatery() then
                        -- Effects
                        particle(p_waterhit,x,y)
                        playsound(sfx_hitwater1)
                        stopchannel(1)
                        -- Free projectile
                        removeobject(id)
                        -- End Turn
                        endturn()
                        break
                end
        end
        -- Timer / Explode
        if (fx==1) then
                objects[id].timer=objects[id].timer-1
        end
        if objects[id].timer<=0 then
                objects[id].health=0
        end
        -- Scroll to projectile
        scroll(x,y)
        objectposition(id,x,y)
end

function cc.heli.object.damage(id,damage)
         if objects[id].health>0 then
                objects[id].health=objects[id].health-damage

         end
end

--------------------------------------------------------------------------------
-- Projectile: Bullet
--------------------------------------------------------------------------------

cc.heli.bullet.id=addprojectile("cc.heli.bullet")                        -- Add Projectile

function cc.heli.bullet.draw(id)                                                                -- Draw
        -- Setup draw mode
        setblend(blend_light)
        setalpha(1)
        setcolor(255,255,0)
        setscale(1,1)
        -- Calculate projectile rotation
        setrotation(math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy)))
        -- Draw projectile
        drawimage(cc.heli.gfx_pro,projectiles[id].x,projectiles[id].y)
        -- Draw Arrow if out of Screen
        outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function cc.heli.bullet.update(id)                                                        -- Update
        -- Wind + Gravity influence on speed
        projectiles[id].sx=projectiles[id].sx+getwind()*0.02
        projectiles[id].sy=projectiles[id].sy+getgravity()*0.75
        -- Move
        cc.heli.bullet.move(id)
end

function cc.heli.bullet.move(id)
        rot=math.deg(math.atan2(projectiles[id].sx,-projectiles[id].sy))
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20,1,1,1,-1,projectiles[id].ignore)==1 then
                        -- Cause damage
                        if playercollision()~=0 then
                                playerpush(playercollision(),projectiles[id].sx/10.0,projectiles[id].sy/10.0)
                                playerdamage(playercollision(),5)
                                blood(projectiles[id].x+math.sin(math.rad(rot))*20,projectiles[id].y-math.cos(math.rad(rot))*20)
                        elseif objectcollision()>0 then
                                objectdamage(objectcollision(),5)
                        end
                        -- Destroy terrain
                        for j=20,22,1 do
                                terraincircle(projectiles[id].x+math.sin(math.rad(rot))*j,projectiles[id].y-math.cos(math.rad(rot))*j,3,0x00000000)
                        end
                        -- Effects
                        playsound(sfx_ricochet1)
                        particle(p_smoke,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                        particlefadealpha(0.006)
                        particle(p_muzzle,projectiles[id].x+math.sin(math.rad(rot))*21,projectiles[id].y-math.cos(math.rad(rot))*21)
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        if math.random(1,2)==1 then
                                playsound(sfx_hitwater2)
                        else
                                playsound(sfx_hitwater3)
                        end
                        -- Free projectile
                        freeprojectile(id)
                        return 1
                end
        end
end

--------------------------------------------------------------------------------
-- Projectile: Rocket
--------------------------------------------------------------------------------

cc.heli.rocket.id=addprojectile("cc.heli.rocket")                -- Add Projectile

function cc.heli.rocket.draw(id)                                                        -- Draw
        -- Setup draw mode
        setblend(blend_alpha)
        setalpha(1)
        setcolor(255,255,255)
        setscale(1,1)
        -- Calculate projectile rotation
        setrotation(projectiles[id].rot)
        -- Draw projectile
        drawimage(cc.heli.gfx_pro2,projectiles[id].x,projectiles[id].y)
        -- Draw Arrow if out of Screen
        outofscreenarrow(projectiles[id].x,projectiles[id].y)
end

function cc.heli.rocket.update(id)                                                -- Update
        cc.heli.rocket.move(id,1)
end

function cc.heli.rocket.move(id,fx)
        rot=projectiles[id].rot
        -- Particle Tail
        if (fx==1) and projectiles[id].timer<0 then
                particle(p_smoke,projectiles[id].x-math.sin(math.rad(rot))*7,projectiles[id].y+math.cos(math.rad(rot))*7)
                particlespeed(math.random(-2,2)*0.1,math.random(-2,2)*0.1)
                particlefadealpha(0.01)
        end

        if (fx==1) then
                projectiles[id].timer=projectiles[id].timer-1
        end
                if projectiles[id].timer<=0 and projectiles[id].timer>-250 then

                if projectiles[id].timer==0 then
                end
                speed=math.sqrt(math.pow(projectiles[id].sx,2)+math.pow(projectiles[id].sy,2))
                if speed<16.0 then
                        speed=speed+0.15
                        if speed>16.0 then speed=16.0 end
                end
                projectiles[id].sx=math.sin(math.rad(rot))*speed
                projectiles[id].sy=2-math.cos(math.rad(rot))*speed
        end
        -- Wind + Gravity influence on speed
        projectiles[id].sx=projectiles[id].sx+getwind()
        projectiles[id].sy=projectiles[id].sy+getgravity()
        -- Move (in substep loop for optimal collision precision)
        msubt=math.ceil(math.max(math.abs(projectiles[id].sx),math.abs(projectiles[id].sy))/3)
        msubx=projectiles[id].sx/msubt
        msuby=projectiles[id].sy/msubt
        for i=1,msubt,1 do
                projectiles[id].x=projectiles[id].x+msubx
                projectiles[id].y=projectiles[id].y+msuby
                -- Collision
                if collision(col3x3,projectiles[id].x+math.sin(math.rad(rot))*3,projectiles[id].y-math.cos(math.rad(rot))*3)==1 or explode==1 then
                        if terraincollision()==1 or objectcollision()~=projectiles[id].ignore or playercollision()>0 then
                                -- Cause damage
                                arealdamage(projectiles[id].x,projectiles[id].y,100,20)
                                -- Destroy terrain
                                terrainexplosion(projectiles[id].x,projectiles[id].y,25,1)
                                -- Crater
                                grey=math.random(0,40)
                                if math.random(0,1)==1 then
                                        terrainalphaimage(gfx_crater100,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
                                else
                                        terrainalphaimage(gfx_crater125,projectiles[id].x,projectiles[id].y,math.random(6,9)*0.1,grey,grey,grey)
                                end
                                -- Free projectile
                                freeprojectile(id)
                                break
                        end
                else
                        projectiles[id].ignore=0
                end
                -- Water
                if (projectiles[id].y)>getwatery()+5 then
                        -- Effects
                        particle(p_waterhit,projectiles[id].x,projectiles[id].y)
                        playsound(sfx_hitwater1)
                        -- Free projectile
                        freeprojectile(id)
                        break
                end
        end
end