

-- Setup Tables
if loooser==nil then loooser={} end
loooser.hostage={}
loooser.hostage.object={}
loooser.hostage.sfx_rescue={}
-- Load & Prepare Ressources
loooser.hostage.gfx_wpn0=loadgfx("players/hostage1.png")                                -- Hostage standing 0
setmidhandle(loooser.hostage.gfx_wpn0)
loooser.hostage.gfx_wpn1=loadgfx("players/hostage2.png")                                -- Hostage walking 1
setmidhandle(loooser.hostage.gfx_wpn1)
loooser.hostage.gfx_wpn2=loadgfx("players/hostage3.png")                                -- hostage walking 2
setmidhandle(loooser.hostage.gfx_wpn2)
for i=1,5 do
loooser.hostage.sfx_rescue[i]=loadsfx("hos"..i..".wav")
end


loooser.hostage.object.id=addobject("loooser.hostage.object",loooser.hostage.gfx_wpn0)                -- Add Object

function loooser.hostage.object.setup(id,parameter)
        if objects==nil then objects={} end
        objects[id]={}
        objects[id].health=100
        objects[id].sy=0
        objects[id].sx=0
        objects[id].dir=1
        objects[id].timer=0
        objects[id].frame=0
        objects[id].lastx=0
end

function loooser.hostage.object.draw(id,x,y)
        -- Setup draw mode
        setblend(blend_alpha)
        setalpha(1)
        setrotation(180)
        setcolor(255,255,255)
        setscale(objects[id].dir,-1)
        -- Draw projectile
        if objects[id].lastx==x then
                 drawimage(loooser.hostage.gfx_wpn0,x,y-2)
        elseif objects[id].frame==0 then
                drawimage(loooser.hostage.gfx_wpn1,x,y-2)
        else
                drawimage(loooser.hostage.gfx_wpn2,x,y-2)
        end

end

function loooser.hostage.object.update(id,x,y)
         objects[id].lastx=x
         if objects[id].health<0 then
                 particle(p_bodypart,x,y)
                 particlecolor(20,20,20)
                 for i = 1,3 do
                         particle(p_bigblood,x,y)
                 end
                 if inmission()==1 then
                    playerdamage(playercurrent(),-1000)
                 end
                 removeobject(id)
                 return
         end
         local heli=objecttable(cc.heli.object.id)
         if heli[1]==nil then
                heli[1]=-1
         end
         if heli[1]~=-1 then
         if getobjectx(heli[1])>x then
                 objects[id].dir=-1
         else
                 objects[id].dir=1
         end
         end
        -- Animation
        objects[id].timer=objects[id].timer+1
        if objects[id].timer>19 then
                objects[id].timer=0
                objects[id].frame=1-objects[id].frame
        end
        if heli[1]~=1 then
        local dist=((x-getobjectx(heli[1]))^2+(y-getobjecty(heli[1]))^2)^0.5
        if dist<70 then
                 playsound(loooser.hostage.sfx_rescue[math.random(1,5)])
           removeobject(id)
           return
        end
        if dist<150 then
        -- Move Left/Right
        if collision(col20x20,x-objects[id].dir*11,y-5,0,1,1,-1,id)==0 or not getobjecttype(objectcollision())==cc.heli.object.id then
         x=x-objects[id].dir*0.5
        end
        if collision(colplayer,x,y,1,1,1,-1,id)==1 then
                if terraincollision()==1 or objectcollision()>0 then
                        -- Upwards/Downwards space?
                        doturn=1
                        for i=1,6,1 do
                                if (i%2)==1 then offset=(i+1)/2 else offset=-(i/2) end
                                if collision(colplayer,x,y+offset,1,1,1,-1,id)==0 then
                                        doturn=0; y=y+offset; break
                                elseif terraincollision()==0 and objectcollision()==0 then
                                        doturn=0; y=y+offset; break
                                end
                        end
                        if doturn==1 then
                                -- Move Back / Turn
                                x=x+objects[id].dir*0.5
                        end
                end
        end
        end
        end
        -- Fall Down
        objects[id].sy=objects[id].sy+getgravity()
        msubt=math.ceil(math.abs(objects[id].sy)/3)
        msuby=objects[id].sy/msubt
        msubx=objects[id].sx/msubt
        for i=1,msubt,1 do
                y=y+msuby
                x=x+msubx
                -- Collision
                if collision(colplayer,x,y,1,1,1,-1,id)==1 then
                        if terraincollision()==1 or objectcollision()>0 or playercollision~=0 then
                                objects[id].sy=0
                                y=y-msuby
                                break
                        end
                end
                -- Water
                if (y)>getwatery()-30 then
                        -- Effects
                        particle(p_waterhit,x,y)
                        playsound(sfx_hitwater3)
                 if inmission()==1 then
                    playerdamage(playercurrent(),-1000)
                 end
                        -- Free projectile
                        removeobject(id)
                        -- End Turn
                        endturn()
                        return
                end
        end
        objectposition(id,x,y)
end

function loooser.hostage.object.damage(id,damage)
        objects[id].health=objects[id].health-damage
        particle(p_bigblood,getobjectx(id),getobjecty(id))
end